%global commit 4c79120bcdbde0616f592458ccde7035e92ca3d8
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Summary:       Utility to set/clear/query executable stack bit
Name:          execstack
Version:       0.5.0
Release:       6%{?dist}
License:       GPLv2+
URL:           https://github.com/keszybz/prelink
Source0:       %{url}/archive/%{commit}.tar.gz#/prelink-%{shortcommit}.tar.gz

Patch3000:     Add-PL_ARCH-for-AArch64.patch
Patch3001:     0002-execstack-configure-c99.patch
Patch3002:     0003-Add-PL_ARCH-for-Loongarch64.patch
 
BuildRequires: gcc gcc-c++ elfutils-libelf-devel libselinux-devel libselinux-utils git make
Requires:      glibc coreutils findutils util-linux gawk grep

%description
This package is built from prelink sources but contains just the execstack binary. It can be used
manipulate ELF binaries to run with or without executable stack.

%prep
%autosetup -n prelink-%{commit} -p1 -Sgit
sed -i -e '/^prelink_LDADD/s/$/ -lpthread/' src/Makefile.{am,in}

%build
%configure
make %{?_smp_mflags} -C gelf
make %{?_smp_mflags} -C gelfx
make %{?_smp_mflags} -C gelfx32
make %{?_smp_mflags} -C src execstack

%check
cp src/execstack test
src/execstack -q test | grep '^-'
src/execstack -s test
src/execstack -q test | grep '^X'
src/execstack -c test
src/execstack -q test | grep '^-'

%install
install -D src/execstack %{buildroot}%{_bindir}/execstack
install -Dm0644 doc/execstack.8 %{buildroot}%{_mandir}/man8/execstack.8

%files
%license COPYING
%doc ChangeLog NEWS README TODO THANKS
%{_bindir}/execstack
%{_mandir}/man8/execstack.8.*

%changelog
* Mon Apr 08 2024 Huang Yang <huangyang@loongson.cn> - 0.5.0-6
- add loongarch64 support

* Wed Jan 17 2024 Rebuild Robot <rebot@opencloudos.org> - 0.5.0-5
- Rebuilt for elfutils

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.5.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.5.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.5.0-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Jan 31 2023 Shuo Wang <abushwang@tencent.com> - 0.5.0-1
- initial build
